package com.fundi.framework.common.navigation;

/*
 *  Common Services Library - Framework plug-in.
 *  (C) Copyright Fundi Software 2011, 2016.  Fundi Confidential.
 *  All rights reserved.  Use, duplication or disclosure restricted. 
 */

import java.util.ArrayList;

import com.fundi.framework.common.instance.AppInstance;
import com.fundi.framework.common.instance.ConnectionServer;

public class FrameworkNavigationProvider extends NavigationProvider {

	//Eye catchers.
	public static final String EC_COPYRIGHT = "(C) Copyright 2011, 2016 Fundi Software.  Fundi Confidential."; //$NON-NLS-1$
	public static final String EC_APAR = "3.1.1.00_00014"; //$NON-NLS-1$
	public static final String EC_FMID = "H30SA10"; //$NON-NLS-1$
	public static final String EC_PID = "5655-CSL"; //$NON-NLS-1$
	
	public FrameworkNavigationProvider() {
		
		super();
	}
	
	public FrameworkNavigationProvider(AppInstance instance) {
	
		super(instance);
	}
	
	public ArrayList<NavigationItem> getNavigationItems() {
		
		return getNavigationItems(true);
	}
	
	public ArrayList<NavigationItem> getNavigationItems(boolean testConnections) {
		
		ArrayList<NavigationItem> items = new ArrayList<NavigationItem>();
		ArrayList<ConnectionServer> connSvrs;
		int idxObj;
		NavigationItem item;
		ArrayList<NavigationItem> groups;
		
		connSvrs = instance.retrieveSavedConnectionServers(testConnections);
		for (idxObj = 0; idxObj < connSvrs.size(); idxObj++) {
			item = new NavigationItem(connSvrs.get(idxObj).getDisplayName(), connSvrs.get(idxObj), null);
			items.add(item);
		}
		
		groups = instance.getNavigationGroups();
		for (idxObj = 0; idxObj < groups.size(); idxObj++) {
			items.add(groups.get(idxObj));
		}
		
		return items;
	}
	
	public ArrayList<NavigationType> getUserCreatableNavigationTypes() {
		
		ArrayList<NavigationType> types = new ArrayList<NavigationType>();
		
		if (!instance.useIBMExplorerConnectionDefns()) {
			types.add(new NavigationType(ConnectionServer.typeName, ConnectionServer.class.getName()));
		}
		types.add(new NavigationType(AppInstance.userGroupType, NavigationItem.class.getName()));
		
		return types;
	}
}
