package com.fundi.framework.common.util;

/*
 *  Common Services Library - Framework plug-in.
 *  (C) Copyright Fundi Software 2011, 2016.  Fundi Confidential.
 *  All rights reserved.  Use, duplication or disclosure restricted. 
 */

import com.fundi.framework.common.nl1.Messages;

public class NumberEditor {

	//Eye catchers.
	public static final String EC_COPYRIGHT = "(C) Copyright 2011, 2016 Fundi Software.  Fundi Confidential."; //$NON-NLS-1$
	public static final String EC_APAR = "3.1.1.00_00014"; //$NON-NLS-1$
	public static final String EC_FMID = "H30SA10"; //$NON-NLS-1$
	public static final String EC_PID = "5655-CSL"; //$NON-NLS-1$
	
	private String textNumber = ""; //$NON-NLS-1$
	private boolean validInteger;
	private boolean inRange;
	private int intValue = 0;
	private double dblValue = 0;
	
	public NumberEditor(String source) {

		super();
		
		validInteger = false;
		inRange = false;
		textNumber = source.trim();
	}
	
	public boolean isNumber() {
		
		try {  
			dblValue = Double.parseDouble(textNumber);
		}  
		catch (NumberFormatException e) {
			return false;
		}

		return true;
	}
	
	public double doubleValue() {
		
		return dblValue;
	}
	
	public boolean isValidInteger(int maxDigits) {

		if (textNumber.length() > maxDigits) {
			validInteger =  false;
		} else {	//MA: added else block as failing this length test was otherwise getting overridden by the integer test.
			try {
				intValue = (new Integer(textNumber)).intValue();
				validInteger =  true;
			}
			catch (NumberFormatException e) {
				validInteger =  false;
			}
		}
		
		return validInteger;
	}
	
	public boolean isInRange(int minValue, int maxValue) {
		
		if (validInteger) {
			if (intValue < minValue || intValue > maxValue) {
				return  false;
			}
			return  true;
		}
		else {
			return false;
		}
	}
	
	public int intValue() {
		
		return intValue;
	}
}
